diff --git a/app/test-bbdev/test_bbdev_perf.c b/app/test-bbdev/test_bbdev_perf.c
index 535b9d73dd..2baa2a0e62 100644
--- a/app/test-bbdev/test_bbdev_perf.c
+++ b/app/test-bbdev/test_bbdev_perf.c
@@ -3161,6 +3161,8 @@ throughput_intr_lcore_ldpc_dec(void *arg)
 				num_to_process);
 	TEST_ASSERT_SUCCESS(ret, "Allocation failed for %d ops",
 			num_to_process);
+	ref_op->ldpc_dec.iter_max = get_iter_max();
+
 	if (test_vector.op_type != RTE_BBDEV_OP_NONE)
 		copy_reference_ldpc_dec_op(ops, num_to_process, 0, bufs->inputs,
 				bufs->hard_outputs, bufs->soft_outputs,
@@ -5238,6 +5240,7 @@ offload_latency_test_dec(struct rte_mempool *mempool, struct test_buffers *bufs,
 
 		ret = rte_bbdev_dec_op_alloc_bulk(mempool, ops_enq, burst_sz);
 		TEST_ASSERT_SUCCESS(ret, "Allocation failed for %d ops", burst_sz);
+		ref_op->turbo_dec.iter_max = get_iter_max();
 		if (test_vector.op_type != RTE_BBDEV_OP_NONE)
 			copy_reference_dec_op(ops_enq, burst_sz, dequeued,
 					bufs->inputs,
@@ -5324,6 +5327,7 @@ offload_latency_test_ldpc_dec(struct rte_mempool *mempool,
 
 		ret = rte_bbdev_dec_op_alloc_bulk(mempool, ops_enq, burst_sz);
 		TEST_ASSERT_SUCCESS(ret, "Allocation failed for %d ops", burst_sz);
+		ref_op->ldpc_dec.iter_max = get_iter_max();
 		if (test_vector.op_type != RTE_BBDEV_OP_NONE)
 			copy_reference_ldpc_dec_op(ops_enq, burst_sz, dequeued,
 					bufs->inputs,
diff --git a/app/test-bbdev/test_bbdev_vector.c b/app/test-bbdev/test_bbdev_vector.c
index 1125395dbf..c26727cd35 100644
--- a/app/test-bbdev/test_bbdev_vector.c
+++ b/app/test-bbdev/test_bbdev_vector.c
@@ -532,10 +532,6 @@ parse_decoder_params(const char *key_token, char *token,
 		vector->mask |= TEST_BBDEV_VF_RV_INDEX;
 		turbo_dec->rv_index = (uint8_t) strtoul(token, &err, 0);
 		ret = ((err == NULL) || (*err != '\0')) ? -1 : 0;
-	} else if (!strcmp(key_token, "iter_max")) {
-		vector->mask |= TEST_BBDEV_VF_ITER_MAX;
-		turbo_dec->iter_max = (uint8_t) strtoul(token, &err, 0);
-		ret = ((err == NULL) || (*err != '\0')) ? -1 : 0;
 	} else if (!strcmp(key_token, "iter_min")) {
 		vector->mask |= TEST_BBDEV_VF_ITER_MIN;
 		turbo_dec->iter_min = (uint8_t) strtoul(token, &err, 0);
@@ -862,10 +858,6 @@ parse_ldpc_decoder_params(const char *key_token, char *token,
 		vector->mask |= TEST_BBDEV_VF_EXPECTED_ITER_COUNT;
 		ldpc_dec->iter_count = (uint8_t) strtoul(token, &err, 0);
 		ret = ((err == NULL) || (*err != '\0')) ? -1 : 0;
-	} else if (!strcmp(key_token, "iter_max")) {
-		vector->mask |= TEST_BBDEV_VF_ITER_MAX;
-		ldpc_dec->iter_max = (uint8_t) strtoul(token, &err, 0);
-		ret = ((err == NULL) || (*err != '\0')) ? -1 : 0;
 	} else if (!strcmp(key_token, "code_block_mode")) {
 		vector->mask |= TEST_BBDEV_VF_CODE_BLOCK_MODE;
 		ldpc_dec->code_block_mode = (uint8_t) strtoul(token, &err, 0);
@@ -1260,9 +1252,6 @@ check_decoder(struct test_bbdev_vector *vector)
 	if (!(mask & TEST_BBDEV_VF_ITER_MIN))
 		printf(
 			"WARNING: iter_min was not specified in vector file and will be set to 0\n");
-	if (!(mask & TEST_BBDEV_VF_ITER_MAX))
-		printf(
-			"WARNING: iter_max was not specified in vector file and will be set to 0\n");
 	if (!(mask & TEST_BBDEV_VF_EXPECTED_ITER_COUNT))
 		printf(
 			"WARNING: expected_iter_count was not specified in vector file and iter_count will not be validated\n");
@@ -1335,9 +1324,6 @@ check_ldpc_decoder(struct test_bbdev_vector *vector)
 	if (!(mask & TEST_BBDEV_VF_RV_INDEX))
 		printf(
 			"INFO: rv_index was not specified in vector file and will be set to 0\n");
-	if (!(mask & TEST_BBDEV_VF_ITER_MAX))
-		printf(
-			"WARNING: iter_max was not specified in vector file and will be set to 0\n");
 	if (!(mask & TEST_BBDEV_VF_EXPECTED_ITER_COUNT))
 		printf(
 			"WARNING: expected_iter_count was not specified in vector file and iter_count will not be validated\n");
diff --git a/app/test-bbdev/test_bbdev_vector.h b/app/test-bbdev/test_bbdev_vector.h
index 4c53e8f137..2ea271ffb7 100644
--- a/app/test-bbdev/test_bbdev_vector.h
+++ b/app/test-bbdev/test_bbdev_vector.h
@@ -19,7 +19,6 @@ enum {
 	TEST_BBDEV_VF_C = (1ULL << 7),
 	TEST_BBDEV_VF_CAB = (1ULL << 8),
 	TEST_BBDEV_VF_RV_INDEX = (1ULL << 9),
-	TEST_BBDEV_VF_ITER_MAX = (1ULL << 10),
 	TEST_BBDEV_VF_ITER_MIN = (1ULL << 11),
 	TEST_BBDEV_VF_EXPECTED_ITER_COUNT = (1ULL << 12),
 	TEST_BBDEV_VF_EXT_SCALE = (1ULL << 13),
diff --git a/app/test-bbdev/test_vectors/ldpc_dec_HARQ_1_0.data b/app/test-bbdev/test_vectors/ldpc_dec_HARQ_1_0.data
index 5d4d27d607..215c30a610 100644
--- a/app/test-bbdev/test_vectors/ldpc_dec_HARQ_1_0.data
+++ b/app/test-bbdev/test_vectors/ldpc_dec_HARQ_1_0.data
@@ -340,9 +340,6 @@ rv_index=
 code_block_mode=
 1
 
-iter_max=
-20
-
 expected_iter_count=
 20
 
diff --git a/app/test-bbdev/test_vectors/ldpc_dec_HARQ_1_1.data b/app/test-bbdev/test_vectors/ldpc_dec_HARQ_1_1.data
index 63c2d3b618..09ffd7b40a 100644
--- a/app/test-bbdev/test_vectors/ldpc_dec_HARQ_1_1.data
+++ b/app/test-bbdev/test_vectors/ldpc_dec_HARQ_1_1.data
@@ -671,9 +671,6 @@ rv_index=
 code_block_mode=
 1
 
-iter_max=
-20
-
 expected_iter_count=
 4
 
diff --git a/app/test-bbdev/test_vectors/ldpc_dec_HARQ_1_2.data b/app/test-bbdev/test_vectors/ldpc_dec_HARQ_1_2.data
index 2463df6178..c1cd088498 100644
--- a/app/test-bbdev/test_vectors/ldpc_dec_HARQ_1_2.data
+++ b/app/test-bbdev/test_vectors/ldpc_dec_HARQ_1_2.data
@@ -889,9 +889,6 @@ rv_index=
 code_block_mode=
 1
 
-iter_max=
-20
-
 expected_iter_count=
 3
 
diff --git a/app/test-bbdev/test_vectors/ldpc_dec_v11835.data b/app/test-bbdev/test_vectors/ldpc_dec_v11835.data
index 84a04e11cc..e899b95e74 100644
--- a/app/test-bbdev/test_vectors/ldpc_dec_v11835.data
+++ b/app/test-bbdev/test_vectors/ldpc_dec_v11835.data
@@ -36,9 +36,6 @@ rv_index=
 code_block_mode=
 1
 
-iter_max=
-20
-
 expected_iter_count=
 4
 
diff --git a/app/test-bbdev/test_vectors/ldpc_dec_v2342_drop.data b/app/test-bbdev/test_vectors/ldpc_dec_v2342_drop.data
index f30726e46a..31fef581b2 100644
--- a/app/test-bbdev/test_vectors/ldpc_dec_v2342_drop.data
+++ b/app/test-bbdev/test_vectors/ldpc_dec_v2342_drop.data
@@ -732,9 +732,6 @@ rv_index =
 code_block_mode =
 1
 
-iter_max =
-20
-
 expected_iter_count =
 3
 
diff --git a/app/test-bbdev/test_vectors/ldpc_dec_v7813.data b/app/test-bbdev/test_vectors/ldpc_dec_v7813.data
index c656fd3e4a..de8fbbc08c 100644
--- a/app/test-bbdev/test_vectors/ldpc_dec_v7813.data
+++ b/app/test-bbdev/test_vectors/ldpc_dec_v7813.data
@@ -35,9 +35,6 @@ rv_index =
 code_block_mode =
 1
 
-iter_max =
-8
-
 expected_iter_count =
 6
 
diff --git a/app/test-bbdev/test_vectors/ldpc_dec_v8480.data b/app/test-bbdev/test_vectors/ldpc_dec_v8480.data
index ddebf7bee1..197ed837cb 100644
--- a/app/test-bbdev/test_vectors/ldpc_dec_v8480.data
+++ b/app/test-bbdev/test_vectors/ldpc_dec_v8480.data
@@ -61,9 +61,6 @@ rv_index =
 code_block_mode =
 1
 
-iter_max =
-8
-
 expected_iter_count =
 3
 
diff --git a/app/test-bbdev/test_vectors/ldpc_dec_v8568.data b/app/test-bbdev/test_vectors/ldpc_dec_v8568.data
index 0b95e4e0fa..b84361f247 100644
--- a/app/test-bbdev/test_vectors/ldpc_dec_v8568.data
+++ b/app/test-bbdev/test_vectors/ldpc_dec_v8568.data
@@ -242,9 +242,6 @@ rv_index =
 code_block_mode =
 1
 
-iter_max =
-20
-
 expected_iter_count =
 6
 
diff --git a/app/test-bbdev/test_vectors/ldpc_dec_v9503.data b/app/test-bbdev/test_vectors/ldpc_dec_v9503.data
index 7699ae3157..4471f8bf5e 100644
--- a/app/test-bbdev/test_vectors/ldpc_dec_v9503.data
+++ b/app/test-bbdev/test_vectors/ldpc_dec_v9503.data
@@ -1202,9 +1202,6 @@ rv_index =
 code_block_mode =
 1
 
-iter_max =
-20
-
 expected_iter_count =
 3
 
diff --git a/app/test-bbdev/test_vectors/turbo_dec_c1_k40_r0_e17280_sbd_negllr.data b/app/test-bbdev/test_vectors/turbo_dec_c1_k40_r0_e17280_sbd_negllr.data
index d98210ff6f..f147c8af53 100644
--- a/app/test-bbdev/test_vectors/turbo_dec_c1_k40_r0_e17280_sbd_negllr.data
+++ b/app/test-bbdev/test_vectors/turbo_dec_c1_k40_r0_e17280_sbd_negllr.data
@@ -31,9 +31,6 @@ k =
 rv_index =
 1
 
-iter_max =
-8
-
 iter_min =
 4
 
diff --git a/app/test-bbdev/test_vectors/turbo_dec_c1_k6144_r0_e10376_crc24b_sbd_negllr_high_snr.data b/app/test-bbdev/test_vectors/turbo_dec_c1_k6144_r0_e10376_crc24b_sbd_negllr_high_snr.data
index 3472c992fd..635078ab27 100644
--- a/app/test-bbdev/test_vectors/turbo_dec_c1_k6144_r0_e10376_crc24b_sbd_negllr_high_snr.data
+++ b/app/test-bbdev/test_vectors/turbo_dec_c1_k6144_r0_e10376_crc24b_sbd_negllr_high_snr.data
@@ -617,9 +617,6 @@ k =
 e =
 10376
 
-iter_max =
-8
-
 iter_min =
 4
 
diff --git a/app/test-bbdev/test_vectors/turbo_dec_c1_k6144_r0_e10376_crc24b_sbd_negllr_low_snr.data b/app/test-bbdev/test_vectors/turbo_dec_c1_k6144_r0_e10376_crc24b_sbd_negllr_low_snr.data
index 8ff71aac42..de6136bd1b 100644
--- a/app/test-bbdev/test_vectors/turbo_dec_c1_k6144_r0_e10376_crc24b_sbd_negllr_low_snr.data
+++ b/app/test-bbdev/test_vectors/turbo_dec_c1_k6144_r0_e10376_crc24b_sbd_negllr_low_snr.data
@@ -617,9 +617,6 @@ k =
 e =
 10376
 
-iter_max =
-8
-
 iter_min =
 4
 
diff --git a/app/test-bbdev/test_vectors/turbo_dec_c1_k6144_r0_e34560_posllr.data b/app/test-bbdev/test_vectors/turbo_dec_c1_k6144_r0_e34560_posllr.data
index fe4f5eefd2..cb28ee1e97 100644
--- a/app/test-bbdev/test_vectors/turbo_dec_c1_k6144_r0_e34560_posllr.data
+++ b/app/test-bbdev/test_vectors/turbo_dec_c1_k6144_r0_e34560_posllr.data
@@ -620,9 +620,6 @@ k =
 rv_index =
 0
 
-iter_max =
-8
-
 iter_min =
 4
 
diff --git a/app/test-bbdev/test_vectors/turbo_dec_c1_k6144_r0_e34560_sbd_negllr.data b/app/test-bbdev/test_vectors/turbo_dec_c1_k6144_r0_e34560_sbd_negllr.data
index b5ef624616..8ec4911d3c 100644
--- a/app/test-bbdev/test_vectors/turbo_dec_c1_k6144_r0_e34560_sbd_negllr.data
+++ b/app/test-bbdev/test_vectors/turbo_dec_c1_k6144_r0_e34560_sbd_negllr.data
@@ -1198,9 +1198,6 @@ k =
 rv_index =
 0
 
-iter_max =
-8
-
 iter_min =
 4
 
diff --git a/app/test-bbdev/test_vectors/turbo_dec_c1_k6144_r0_e34560_sbd_posllr.data b/app/test-bbdev/test_vectors/turbo_dec_c1_k6144_r0_e34560_sbd_posllr.data
index 13ad0908ce..b6a73c6c07 100644
--- a/app/test-bbdev/test_vectors/turbo_dec_c1_k6144_r0_e34560_sbd_posllr.data
+++ b/app/test-bbdev/test_vectors/turbo_dec_c1_k6144_r0_e34560_sbd_posllr.data
@@ -1199,9 +1199,6 @@ k =
 rv_index =
 0
 
-iter_max =
-8
-
 iter_min =
 4
 
diff --git a/app/test-bbdev/test_vectors/turbo_dec_c2_k3136_r0_e4920_sbd_negllr_crc24b.data b/app/test-bbdev/test_vectors/turbo_dec_c2_k3136_r0_e4920_sbd_negllr_crc24b.data
index cfff56ad9a..9d17b86c43 100644
--- a/app/test-bbdev/test_vectors/turbo_dec_c2_k3136_r0_e4920_sbd_negllr_crc24b.data
+++ b/app/test-bbdev/test_vectors/turbo_dec_c2_k3136_r0_e4920_sbd_negllr_crc24b.data
@@ -651,9 +651,6 @@ k_pos =
 rv_index =
 0
 
-iter_max =
-8
-
 iter_min =
 4
 